<?php
namespace Teknisa\OPL\Modules\Consolidacao\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class Sup07200LancamentoDePedidosReport extends \Zeedhi\Framework\Controller\Report {
    protected $entityManager;
    protected $birtStrategy;
    protected $newCode;
    protected $environment;
    protected $connection;
    protected $dataSourceManager;
    protected $qr2Strategy;

    public function __construct($reportService, $entityManager, $reportStrategies, $newCode, $environment, $connection, $dataSourceManager, $qr2Strategy) {
        $this->entityManager     = $entityManager;
        $this->reportStrategies  = $reportStrategies;
        $this->reportService     = $reportService;
        $this->newCode           = $newCode;
        $this->environment       = $environment;
        $this->connection        = $connection;
        $this->dataSourceManager = $dataSourceManager;
        $this->qr2Strategy       = $qr2Strategy;
    }
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        ini_set('default_socket_timeout', 10000);
        
        $row = $request->getRow();
        
        $this->qr2Strategy->setQr2Type($row["QR2TYPE"]);
        $this->stNomeRel = $this->getReportName($row);
        $this->reportMapping[$this->stNomeRel] = array(
            "strategy" => isset($row["STRATEGY"]) ? $row["STRATEGY"] : "QR2",
            "parameterMapping" => array(
                "P_CDCLIENTE"       => "P_CDCLIENTE",
                "P_TCDCLIENTE"      => "P_TCDCLIENTE",
                "P_CDFILIOL"        => "P_CDFILIOL",
                "P_TCDFILIOL"       => "P_TCDFILIOL",
                "L_ROTA"            => "L_ROTA",
                "L_ROTA1"           => "L_ROTA1",
                "P_ROTA"            => "P_ROTA",
                "P_CDFILIAL"        => "P_CDFILIAL",
                "P_TCDFILIAL"       => "P_TCDFILIAL",
                "P_DTENTRINI"       => "P_DTENTRINI",
                "P_DTENTRFIN"       => "P_DTENTRFIN",
                "P_TDTENTR"         => "P_TDTENTR",
                "P_DTEMBINI"        => "P_DTEMBINI",
                "P_DTEMBFIN"        => "P_DTEMBFIN",
                "P_TDTEMB"          => "P_TDTEMB",
                "P_SUBGRUPO"        => "P_SUBGRUPO",
                "P_CDGRUPPROD"      => "P_CDGRUPPROD",
                "P_CDPRODINI"       => "P_CDPRODINI",
                "P_CDPRODFIN"       => "P_CDPRODFIN",
                "P_CDPRODFINTEXT"   => "P_CDPRODFINTEXT",
                "L_PRODUTO"         => "L_PRODUTO",
                "P_PRODUTO"         => "P_PRODUTO",
                "L_OPERADOR"        => "L_OPERADOR",
                "L_OPERADOR1"       => "L_OPERADOR1",
                "P_OPERADOR"        => "P_OPERADOR",
                "P_NMPRODINI"       => "P_NMPRODINI",
                "P_NMPRODFIN"       => "P_NMPRODFIN",
                "P_IDSITUACAO"      => "P_IDSITUACAO",
                "P_IDBAIXEXOL"      => "P_IDBAIXEXOL",
                "P_IDBAIXEXSAI"     => "P_IDBAIXEXSAI",
                "P_PEDEXOLEXTR"     => "P_PEDEXOLEXTR",
                "P_CDLOTENVITOL"    => "P_CDLOTENVITOL",
                "P_NRSEQRUPTURAOL"  => "P_NRSEQRUPTURAOL",
                "P_TNRSEQRUPTURAOL" => "P_TNRSEQRUPTURAOL"
            )
        );
    }
}